1.57.0 (latest) 1.56.0 1.55.0 1.54.0 1.53.0 1.52.0 1.51.0 1.50.0 1.49.0 1.48.0 1.41.0 1.40.0 1.39.0 1.38.0 1.37.0 1.36.0 1.35.0 1.34.0 1.33.0 1.32.0 1.31.0 1.30.0 1.29.0 1.28.0 1.27.0 1.26.0 1.25.0 1.24.0 1.23.0 1.22.0 1.21.0 1.20.1 1.19.2 1.18.0 1.17.0 1.16.1 1.15.0 1.14.1 1.13.0 1.12.1 1.11.0 1.10.1 1.9.0 1.8.0 1.7.0 1.6.1 1.5.2 1.4.0 1.3.2 1.2.0 1.1.0 1.0.0 0.9.0 0.8.0 0.7.0 0.6.0 0.5.0 0.4.2 0.3.0 0.2.1 0.1.0

```python
RegionInstanceGroupsClient(
    *,
    credentials: typing.Optional[google.auth.credentials.Credentials] = None,
    transport: typing.Optional[
        typing.Union[
            str,
            google.cloud.compute_v1.services.region_instance_groups.transports.base.RegionInstanceGroupsTransport,
            typing.Callable[
                [...],
                google.cloud.compute_v1.services.region_instance_groups.transports.base.RegionInstanceGroupsTransport,
            ],
        ]
    ] = None,
    client_options: typing.Optional[
        typing.Union[google.api_core.client_options.ClientOptions, dict]
    ] = None,
    client_info: google.api_core.gapic_v1.client_info.ClientInfo = google.api_core.gapic_v1.client_info.ClientInfo
)
```
The RegionInstanceGroups API. This class implements API version 2026-11-01.

## Properties

### api_endpoint

Return the API endpoint used by the client instance.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `str` | The API endpoint used by the client instance. |

### transport

Returns the transport used by the client instance.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `RegionInstanceGroupsTransport` | The transport used by the client instance. |

### universe_domain

Return the universe domain used by the client instance.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `str` | The universe domain used by the client instance. |

## Methods

### RegionInstanceGroupsClient

```python
RegionInstanceGroupsClient(
    *,
    credentials: typing.Optional[google.auth.credentials.Credentials] = None,
    transport: typing.Optional[
        typing.Union[
            str,
            google.cloud.compute_v1.services.region_instance_groups.transports.base.RegionInstanceGroupsTransport,
            typing.Callable[
                [...],
                google.cloud.compute_v1.services.region_instance_groups.transports.base.RegionInstanceGroupsTransport,
            ],
        ]
    ] = None,
    client_options: typing.Optional[
        typing.Union[google.api_core.client_options.ClientOptions, dict]
    ] = None,
    client_info: google.api_core.gapic_v1.client_info.ClientInfo = google.api_core.gapic_v1.client_info.ClientInfo
)
```
Instantiates the region instance groups client.

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `credentials` | `Optional[google.auth.credentials.Credentials]` The authorization credentials to attach to requests. These credentials identify the application to the service; if none are specified, the client will attempt to ascertain the credentials from the environment. |
| `transport` | `Optional[Union[str,RegionInstanceGroupsTransport,Callable[..., RegionInstanceGroupsTransport]]]` The transport to use, or a Callable that constructs and returns a new transport. If a Callable is given, it will be called with the same set of initialization arguments as used in the RegionInstanceGroupsTransport constructor. If set to None, a transport is chosen automatically. NOTE: "rest" transport functionality is currently in a beta state (preview). We welcome your feedback via an issue in this library's source repository. |
| `client_options` | `Optional[Union[google.api_core.client_options.ClientOptions, dict]]` Custom options for the client. 1. The `api_endpoint` property can be used to override the default endpoint provided by the client when `transport` is not explicitly provided. Only if this property is not set and `transport` was not explicitly provided, the endpoint is determined by the GOOGLE_API_USE_MTLS_ENDPOINT environment variable, which have one of the following values: "always" (always use the default mTLS endpoint), "never" (always use the default regular endpoint) and "auto" (auto-switch to the default mTLS endpoint if client certificate is present; this is the default value). 2. If the GOOGLE_API_USE_CLIENT_CERTIFICATE environment variable is "true", then the `client_cert_source` property can be used to provide a client certificate for mTLS transport. If not provided, the default SSL client certificate will be used if present. If GOOGLE_API_USE_CLIENT_CERTIFICATE is "false" or not set, no client certificate will be used. 3. The `universe_domain` property can be used to override the default "googleapis.com" universe. Note that the `api_endpoint` property still takes precedence; and `universe_domain` is currently not supported for mTLS. |
| `client_info` | `google.api_core.gapic_v1.client_info.ClientInfo` The client info used to send a user-agent string along with API requests. If `None`, then default info will be used. Generally, you only need to set this if you're developing your own client library. |

| **Exceptions** ||
|---|---|
| **Type** | **Description** |
| `google.auth.exceptions.MutualTLSChannelError` | If mutual TLS transport creation failed for any reason. |

### __exit__

```python
__exit__(type, value, traceback)
```
Releases underlying transport's resources.

> [!WARNING]
> **Warning:** ONLY use as a context manager if the transport is NOT shared with other clients! Exiting the with block will CLOSE the transport and may cause errors in other clients!

### common_billing_account_path

```python
common_billing_account_path(billing_account: str) -> str
```
Returns a fully-qualified billing_account string.

### common_folder_path

```python
common_folder_path(folder: str) -> str
```
Returns a fully-qualified folder string.

### common_location_path

```python
common_location_path(project: str, location: str) -> str
```
Returns a fully-qualified location string.

### common_organization_path

```python
common_organization_path(organization: str) -> str
```
Returns a fully-qualified organization string.

### common_project_path

```python
common_project_path(project: str) -> str
```
Returns a fully-qualified project string.

### from_service_account_file

```python
from_service_account_file(filename: str, *args, **kwargs)
```
Creates an instance of this client using the provided credentials
file.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `filename` | `str` The path to the service account private key json file. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `RegionInstanceGroupsClient` | The constructed client. |

### from_service_account_info

```python
from_service_account_info(info: dict, *args, **kwargs)
```
Creates an instance of this client using the provided credentials
info.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `info` | `dict` The service account private key info. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `RegionInstanceGroupsClient` | The constructed client. |

### from_service_account_json

```python
from_service_account_json(filename: str, *args, **kwargs)
```
Creates an instance of this client using the provided credentials
file.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `filename` | `str` The path to the service account private key json file. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `RegionInstanceGroupsClient` | The constructed client. |

### get

```python
get(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.GetRegionInstanceGroupRequest, dict
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    instance_group: typing.Optional[str] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.cloud.compute_v1.types.compute.InstanceGroup
```
Returns the specified instance group resource.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_get():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.GetRegionInstanceGroupRequest(
        instance_group="instance_group_value",
        project="project_value",
        region="region_value",
    )

    # Make the request
    response = client.get(request=request)

    # Handle the response
    print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.GetRegionInstanceGroupRequest, dict]` The request object. A request message for RegionInstanceGroups.Get. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` Name of the region scoping this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `instance_group` | `str` Name of the instance group resource to return. This corresponds to the `instance_group` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `google.cloud.compute_v1.types.InstanceGroup` | Represents an Instance Group resource. Instance Groups can be used to configure a target forload balancing. Instance groups can either be managed or unmanaged. To create managed instance groups, use the instanceGroupManager orregionInstanceGroupManager resource instead. Use zonal unmanaged instance groups if you need to applyload balancing to groups of heterogeneous instances or if you need to manage the instances yourself. You cannot create regional unmanaged instance groups. For more information, readInstance groups. |

### get_mtls_endpoint_and_cert_source

```python
get_mtls_endpoint_and_cert_source(
    client_options: typing.Optional[
        google.api_core.client_options.ClientOptions
    ] = None,
)
```
Deprecated. Return the API endpoint and client cert source for mutual TLS.

The client cert source is determined in the following order:
(1) if `GOOGLE_API_USE_CLIENT_CERTIFICATE` environment variable is not "true", the
client cert source is None.
(2) if `client_options.client_cert_source` is provided, use the provided one; if the
default client cert source exists, use the default one; otherwise the client cert
source is None.

The API endpoint is determined in the following order:
(1) if `client_options.api_endpoint` if provided, use the provided one.
(2) if `GOOGLE_API_USE_CLIENT_CERTIFICATE` environment variable is "always", use the
default mTLS endpoint; if the environment variable is "never", use the default API
endpoint; otherwise if client cert source exists, use the default mTLS endpoint, otherwise
use the default API endpoint.

More details can be found at <https://google.aip.dev/auth/4114>.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `client_options` | `google.api_core.client_options.ClientOptions` Custom options for the client. Only the `api_endpoint` and `client_cert_source` properties may be used in this method. |

| **Exceptions** ||
|---|---|
| **Type** | **Description** |
| `google.auth.exceptions.MutualTLSChannelError` | If any errors happen. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `Tuple[str, Callable[[], Tuple[bytes, bytes]]]` | returns the API endpoint and the client cert source to use. |

### list

```python
list(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.ListRegionInstanceGroupsRequest, dict
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.cloud.compute_v1.services.region_instance_groups.pagers.ListPager
```
Retrieves the list of instance group resources
contained within the specified region.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_list():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.ListRegionInstanceGroupsRequest(
        project="project_value",
        region="region_value",
    )

    # Make the request
    page_result = client.list(request=request)

    # Handle the response
    for response in page_result:
        print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.ListRegionInstanceGroupsRequest, dict]` The request object. A request message for RegionInstanceGroups.List. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` Name of the region scoping this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `google.cloud.compute_v1.services.region_instance_groups.pagers.ListPager` | Contains a list of InstanceGroup resources. Iterating over this object will yield results and resolve additional pages automatically. |

### list_instances

```python
list_instances(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.ListInstancesRegionInstanceGroupsRequest,
            dict,
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    instance_group: typing.Optional[str] = None,
    region_instance_groups_list_instances_request_resource: typing.Optional[
        google.cloud.compute_v1.types.compute.RegionInstanceGroupsListInstancesRequest
    ] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.cloud.compute_v1.services.region_instance_groups.pagers.ListInstancesPager
```
Lists the instances in the specified instance group
and displays information about the named ports.
Depending on the specified options, this method can list
all instances or only the instances that are running.
The orderBy query parameter is not supported.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_list_instances():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.ListInstancesRegionInstanceGroupsRequest(
        instance_group="instance_group_value",
        project="project_value",
        region="region_value",
    )

    # Make the request
    page_result = client.list_instances(request=request)

    # Handle the response
    for response in page_result:
        print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.ListInstancesRegionInstanceGroupsRequest, dict]` The request object. A request message for RegionInstanceGroups.ListInstances. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` Name of the region scoping this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `instance_group` | `str` Name of the regional instance group for which we want to list the instances. This corresponds to the `instance_group` field on the `request` instance; if `request` is provided, this should not be set. |
| `region_instance_groups_list_instances_request_resource` | `google.cloud.compute_v1.types.RegionInstanceGroupsListInstancesRequest` The body resource for this request This corresponds to the `region_instance_groups_list_instances_request_resource` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `google.cloud.compute_v1.services.region_instance_groups.pagers.ListInstancesPager` | Iterating over this object will yield results and resolve additional pages automatically. |

### parse_common_billing_account_path

```python
parse_common_billing_account_path(path: str) -> typing.Dict[str, str]
```
Parse a billing_account path into its component segments.

### parse_common_folder_path

```python
parse_common_folder_path(path: str) -> typing.Dict[str, str]
```
Parse a folder path into its component segments.

### parse_common_location_path

```python
parse_common_location_path(path: str) -> typing.Dict[str, str]
```
Parse a location path into its component segments.

### parse_common_organization_path

```python
parse_common_organization_path(path: str) -> typing.Dict[str, str]
```
Parse a organization path into its component segments.

### parse_common_project_path

```python
parse_common_project_path(path: str) -> typing.Dict[str, str]
```
Parse a project path into its component segments.

### set_named_ports

```python
set_named_ports(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.SetNamedPortsRegionInstanceGroupRequest,
            dict,
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    instance_group: typing.Optional[str] = None,
    region_instance_groups_set_named_ports_request_resource: typing.Optional[
        google.cloud.compute_v1.types.compute.RegionInstanceGroupsSetNamedPortsRequest
    ] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.api_core.extended_operation.ExtendedOperation
```
Sets the named ports for the specified regional
instance group.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_set_named_ports():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.SetNamedPortsRegionInstanceGroupRequest(
        instance_group="instance_group_value",
        project="project_value",
        region="region_value",
    )

    # Make the request
    response = client.set_named_ports(request=request)

    # Handle the response
    print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.SetNamedPortsRegionInstanceGroupRequest, dict]` The request object. A request message for RegionInstanceGroups.SetNamedPorts. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` Name of the region scoping this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `instance_group` | `str` The name of the regional instance group where the named ports are updated. This corresponds to the `instance_group` field on the `request` instance; if `request` is provided, this should not be set. |
| `region_instance_groups_set_named_ports_request_resource` | `google.cloud.compute_v1.types.RegionInstanceGroupsSetNamedPortsRequest` The body resource for this request This corresponds to the `region_instance_groups_set_named_ports_request_resource` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `google.api_core.extended_operation.ExtendedOperation` | An object representing a extended long-running operation. |

### set_named_ports_unary

```python
set_named_ports_unary(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.SetNamedPortsRegionInstanceGroupRequest,
            dict,
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    instance_group: typing.Optional[str] = None,
    region_instance_groups_set_named_ports_request_resource: typing.Optional[
        google.cloud.compute_v1.types.compute.RegionInstanceGroupsSetNamedPortsRequest
    ] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.cloud.compute_v1.types.compute.Operation
```
Sets the named ports for the specified regional
instance group.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_set_named_ports():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.SetNamedPortsRegionInstanceGroupRequest(
        instance_group="instance_group_value",
        project="project_value",
        region="region_value",
    )

    # Make the request
    response = client.set_named_ports(request=request)

    # Handle the response
    print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.SetNamedPortsRegionInstanceGroupRequest, dict]` The request object. A request message for RegionInstanceGroups.SetNamedPorts. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` Name of the region scoping this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `instance_group` | `str` The name of the regional instance group where the named ports are updated. This corresponds to the `instance_group` field on the `request` instance; if `request` is provided, this should not be set. |
| `region_instance_groups_set_named_ports_request_resource` | `google.cloud.compute_v1.types.RegionInstanceGroupsSetNamedPortsRequest` The body resource for this request This corresponds to the `region_instance_groups_set_named_ports_request_resource` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `google.api_core.extended_operation.ExtendedOperation` | An object representing a extended long-running operation. |

### test_iam_permissions

```python
test_iam_permissions(
    request: typing.Optional[
        typing.Union[
            google.cloud.compute_v1.types.compute.TestIamPermissionsRegionInstanceGroupRequest,
            dict,
        ]
    ] = None,
    *,
    project: typing.Optional[str] = None,
    region: typing.Optional[str] = None,
    resource: typing.Optional[str] = None,
    test_permissions_request_resource: typing.Optional[
        google.cloud.compute_v1.types.compute.TestPermissionsRequest
    ] = None,
    retry: typing.Optional[
        typing.Union[
            google.api_core.retry.retry_unary.Retry,
            google.api_core.gapic_v1.method._MethodDefault,
        ]
    ] = _MethodDefault._DEFAULT_VALUE,
    timeout: typing.Union[float, object] = _MethodDefault._DEFAULT_VALUE,
    metadata: typing.Sequence[typing.Tuple[str, typing.Union[str, bytes]]] = ()
) -> google.cloud.compute_v1.types.compute.TestPermissionsResponse
```
Returns permissions that a caller has on the
specified resource.

```python
# This snippet has been automatically generated and should be regarded as a
# code template only.
# It will require modifications to work:
# - It may require correct/in-range values for request initialization.
# - It may require specifying regional endpoints when creating the service
#   client as shown in:
#   https://googleapis.dev/python/google-api-core/latest/client_options.html
from google.cloud import compute_v1

def sample_test_iam_permissions():
    # Create a client
    client = compute_v1.RegionInstanceGroupsClient()

    # Initialize request argument(s)
    request = compute_v1.TestIamPermissionsRegionInstanceGroupRequest(
        project="project_value",
        region="region_value",
        resource="resource_value",
    )

    # Make the request
    response = client.test_iam_permissions(request=request)

    # Handle the response
    print(response)
```

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `request` | `Union[google.cloud.compute_v1.types.TestIamPermissionsRegionInstanceGroupRequest, dict]` The request object. A request message for RegionInstanceGroups.TestIamPermissions. See the method description for details. |
| `project` | `str` Project ID for this request. This corresponds to the `project` field on the `request` instance; if `request` is provided, this should not be set. |
| `region` | `str` The name of the region for this request. This corresponds to the `region` field on the `request` instance; if `request` is provided, this should not be set. |
| `resource` | `str` Name or id of the resource for this request. This corresponds to the `resource` field on the `request` instance; if `request` is provided, this should not be set. |
| `test_permissions_request_resource` | `google.cloud.compute_v1.types.TestPermissionsRequest` The body resource for this request This corresponds to the `test_permissions_request_resource` field on the `request` instance; if `request` is provided, this should not be set. |
| `retry` | `google.api_core.retry.Retry` Designation of what errors, if any, should be retried. |
| `timeout` | `float` The timeout for this request. |
| `metadata` | `Sequence[Tuple[str, Union[str, bytes]]]` Key/value pairs which should be sent along with the request as metadata. Normally, each value must be of type `str`, but for metadata keys ending with the suffix `-bin`, the corresponding values must be of type `bytes`. |